Linux Audio

Check our new training course

Loading...
v6.9.4
  1# SPDX-License-Identifier: GPL-2.0-only
  2# Makefile for the different targets used to generate full packages of a kernel
  3
  4include $(srctree)/scripts/Kbuild.include
  5include $(srctree)/scripts/Makefile.lib
  6
  7# Git
  8# ---------------------------------------------------------------------------
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
  9
 10filechk_HEAD = git -C $(srctree) rev-parse --verify HEAD 2>/dev/null
 11
 12.tmp_HEAD: check-git FORCE
 13	$(call filechk,HEAD)
 14
 15PHONY += check-git
 16check-git:
 17	@if ! $(srctree)/scripts/check-git; then \
 18		echo >&2 "error: creating source package requires git repository"; \
 19		false; \
 20	fi
 21
 22git-config-tar.gz   = -c tar.tar.gz.command="$(KGZIP)"
 23git-config-tar.bz2  = -c tar.tar.bz2.command="$(KBZIP2)"
 24git-config-tar.lzma = -c tar.tar.lzma.command="$(LZMA)"
 25git-config-tar.xz   = -c tar.tar.xz.command="$(XZ)"
 26git-config-tar.zst  = -c tar.tar.zst.command="$(ZSTD)"
 27
 28quiet_cmd_archive = ARCHIVE $@
 29      cmd_archive = git -C $(srctree) $(git-config-tar$(suffix $@)) archive \
 30                    --output=$$(realpath $@) $(archive-args)
 31
 32suffix-gzip  := .gz
 33suffix-bzip2 := .bz2
 34suffix-lzma  := .lzma
 35suffix-xz    := .xz
 36
 37# Linux source tarball
 38# ---------------------------------------------------------------------------
 39
 40linux-tarballs := $(addprefix linux, .tar.gz .tar.bz2 .tar.lzma .tar.xz)
 41
 42targets += $(linux-tarballs)
 43$(linux-tarballs): archive-args = --prefix=linux/ $$(cat $<)
 44$(linux-tarballs): .tmp_HEAD FORCE
 45	$(call if_changed,archive)
 46
 47# rpm-pkg srcrpm-pkg binrpm-pkg
 48# ---------------------------------------------------------------------------
 49
 50quiet_cmd_mkspec = GEN     $@
 51      cmd_mkspec = $(srctree)/scripts/package/mkspec $@
 52
 53rpmbuild/SPECS/kernel.spec: FORCE
 54	$(call cmd,mkspec)
 55
 56PHONY += rpm-sources
 57rpm-sources: linux.tar.gz
 58	$(Q)mkdir -p rpmbuild/SOURCES
 59	$(Q)ln -f linux.tar.gz rpmbuild/SOURCES/linux.tar.gz
 60	$(Q)cp $(KCONFIG_CONFIG) rpmbuild/SOURCES/config
 61	$(Q)$(srctree)/scripts/package/gen-diff-patch rpmbuild/SOURCES/diff.patch
 62
 63PHONY += rpm-pkg srcrpm-pkg binrpm-pkg
 64
 65rpm-pkg:    private build-type := a
 66srcrpm-pkg: private build-type := s
 67binrpm-pkg: private build-type := b
 68
 69rpm-pkg srcrpm-pkg: rpm-sources
 70rpm-pkg srcrpm-pkg binrpm-pkg: rpmbuild/SPECS/kernel.spec
 71	+$(strip rpmbuild -b$(build-type) rpmbuild/SPECS/kernel.spec \
 72	--define='_topdir $(abspath rpmbuild)' \
 73	$(if $(filter a b, $(build-type)), \
 74		--target $(UTS_MACHINE)-linux --build-in-place --noprep --define='_smp_mflags %{nil}' \
 75		$$(rpm -q rpm >/dev/null 2>&1 || echo --nodeps)) \
 76	$(RPMOPTS))
 77
 78# deb-pkg srcdeb-pkg bindeb-pkg
 79# ---------------------------------------------------------------------------
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 80
 81KDEB_SOURCE_COMPRESS ?= gzip
 82
 83supported-deb-source-compress := gzip bzip2 lzma xz
 84
 85PHONY += linux.tar.unsupported-deb-src-compress
 86linux.tar.unsupported-deb-src-compress:
 87	@echo "error: KDEB_SOURCE_COMPRESS=$(KDEB_SOURCE_COMPRESS) is not supported. The supported values are: $(supported-deb-source-compress)" >&2
 88	@false
 89
 90debian-orig-suffix := \
 91    $(strip $(if $(filter $(supported-deb-source-compress), $(KDEB_SOURCE_COMPRESS)), \
 92    $(suffix-$(KDEB_SOURCE_COMPRESS)),.unsupported-deb-src-compress))
 93
 94quiet_cmd_debianize = GEN     $@
 95      cmd_debianize = $(srctree)/scripts/package/mkdebian $(mkdebian-opts)
 96
 97debian: FORCE
 98	$(call cmd,debianize)
 99
100PHONY += debian-orig
101debian-orig: private source = $(shell dpkg-parsechangelog -S Source)
102debian-orig: private version = $(shell dpkg-parsechangelog -S Version | sed 's/-[^-]*$$//')
103debian-orig: private orig-name = $(source)_$(version).orig.tar$(debian-orig-suffix)
104debian-orig: mkdebian-opts = --need-source
105debian-orig: linux.tar$(debian-orig-suffix) debian
106	$(Q)if [ "$(df  --output=target .. 2>/dev/null)" = "$(df --output=target $< 2>/dev/null)" ]; then \
107		ln -f $< ../$(orig-name); \
108	else \
109		cp $< ../$(orig-name); \
110	fi
111
112PHONY += deb-pkg srcdeb-pkg bindeb-pkg
113
114deb-pkg:    private build-type := source,binary
115srcdeb-pkg: private build-type := source
116bindeb-pkg: private build-type := binary
117
118deb-pkg srcdeb-pkg: debian-orig
119bindeb-pkg: debian
120deb-pkg srcdeb-pkg bindeb-pkg:
121	+$(strip dpkg-buildpackage \
122	--build=$(build-type) --no-pre-clean --unsigned-changes \
123	$(if $(findstring source, $(build-type)), \
124		--unsigned-source --compression=$(KDEB_SOURCE_COMPRESS)) \
125	$(if $(findstring binary, $(build-type)), \
126		-R'$(MAKE) -f debian/rules' -j1 -a$$(cat debian/arch), \
127		--no-check-builddeps) \
128	$(DPKG_FLAGS))
129
130# snap-pkg
131# ---------------------------------------------------------------------------
132PHONY += snap-pkg
133snap-pkg:
134	rm -rf $(objtree)/snap
135	mkdir $(objtree)/snap
136	$(MAKE) clean
 
137	sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
138		s@SRCTREE@$(realpath $(srctree))@" \
139		$(srctree)/scripts/package/snapcraft.template > \
140		$(objtree)/snap/snapcraft.yaml
141	cd $(objtree)/snap && \
142	snapcraft --target-arch=$(UTS_MACHINE)
143
144# dir-pkg tar*-pkg - tarball targets
145# ---------------------------------------------------------------------------
146
147tar-install: FORCE
148	$(Q)$(MAKE) -f $(srctree)/Makefile
149	+$(Q)$(srctree)/scripts/package/buildtar $@
150
151compress-tar.gz  = -I "$(KGZIP)"
152compress-tar.bz2 = -I "$(KBZIP2)"
153compress-tar.xz  = -I "$(XZ)"
154compress-tar.zst = -I "$(ZSTD)"
155
156quiet_cmd_tar = TAR     $@
157      cmd_tar = cd $<; tar cf ../$@ $(compress-tar$(suffix $@)) --owner=root --group=root --sort=name *
158
159dir-tarballs := $(addprefix linux-$(KERNELRELEASE)-$(ARCH), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
160
161$(dir-tarballs): tar-install
162	$(call cmd,tar)
163
164PHONY += dir-pkg
165dir-pkg: tar-install
166	@echo "Kernel tree successfully created in $<"
167
168PHONY += tar-pkg
169tar-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar
170	@:
171
172tar%-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar.% FORCE
173	@:
174
175# perf-tar*-src-pkg - generate a source tarball with perf source
176# ---------------------------------------------------------------------------
177
178.tmp_perf:
179	$(Q)mkdir .tmp_perf
180
181.tmp_perf/HEAD: .tmp_HEAD | .tmp_perf
182	$(call cmd,copy)
183
184quiet_cmd_perf_version_file = GEN     $@
185      cmd_perf_version_file = cd $(srctree)/tools/perf; util/PERF-VERSION-GEN $(dir $(abspath $@))
186
187# PERF-VERSION-FILE and .tmp_HEAD are independent, but this avoids updating the
188# timestamp of PERF-VERSION-FILE.
189# The best is to fix tools/perf/util/PERF-VERSION-GEN.
190.tmp_perf/PERF-VERSION-FILE: .tmp_HEAD $(srctree)/tools/perf/util/PERF-VERSION-GEN | .tmp_perf
191	$(call cmd,perf_version_file)
192
193perf-archive-args = --add-file=$$(realpath $(word 2, $^)) \
194	--add-file=$$(realpath $(word 3, $^)) \
195	$$(cat $(word 2, $^))^{tree} $$(cat $<)
196
197
198perf-tarballs := $(addprefix perf-$(KERNELVERSION), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
199
200targets += $(perf-tarballs)
201$(perf-tarballs): archive-args = --prefix=perf-$(KERNELVERSION)/ $(perf-archive-args)
202$(perf-tarballs): tools/perf/MANIFEST .tmp_perf/HEAD .tmp_perf/PERF-VERSION-FILE FORCE
203	$(call if_changed,archive)
204
205PHONY += perf-tar-src-pkg
206perf-tar-src-pkg: perf-$(KERNELVERSION).tar
207	@:
208
209perf-tar%-src-pkg: perf-$(KERNELVERSION).tar.% FORCE
210	@:
211
212# Help text displayed when executing 'make help'
213# ---------------------------------------------------------------------------
214PHONY += help
215help:
216	@echo '  rpm-pkg             - Build both source and binary RPM kernel packages'
217	@echo '  srcrpm-pkg          - Build only the source kernel RPM package'
218	@echo '  binrpm-pkg          - Build only the binary kernel RPM package'
219	@echo '  deb-pkg             - Build both source and binary deb kernel packages'
220	@echo '  srcdeb-pkg          - Build only the source kernel deb package'
221	@echo '  bindeb-pkg          - Build only the binary kernel deb package'
222	@echo '  snap-pkg            - Build only the binary kernel snap package'
223	@echo '                        (will connect to external hosts)'
224	@echo '  dir-pkg             - Build the kernel as a plain directory structure'
225	@echo '  tar-pkg             - Build the kernel as an uncompressed tarball'
226	@echo '  targz-pkg           - Build the kernel as a gzip compressed tarball'
227	@echo '  tarbz2-pkg          - Build the kernel as a bzip2 compressed tarball'
228	@echo '  tarxz-pkg           - Build the kernel as a xz compressed tarball'
229	@echo '  tarzst-pkg          - Build the kernel as a zstd compressed tarball'
230	@echo '  perf-tar-src-pkg    - Build the perf source tarball with no compression'
231	@echo '  perf-targz-src-pkg  - Build the perf source tarball with gzip compression'
232	@echo '  perf-tarbz2-src-pkg - Build the perf source tarball with bz2 compression'
233	@echo '  perf-tarxz-src-pkg  - Build the perf source tarball with xz compression'
234	@echo '  perf-tarzst-src-pkg - Build the perf source tarball with zst compression'
235
236PHONY += FORCE
237FORCE:
238
239# Read all saved command lines and dependencies for the $(targets) we
240# may be building above, using $(if_changed{,_dep}). As an
241# optimization, we don't need to read them if the target does not
242# exist, we will rebuild anyway in that case.
243
244existing-targets := $(wildcard $(sort $(targets)))
245
246-include $(foreach f,$(existing-targets),$(dir $(f)).$(notdir $(f)).cmd)
247
248.PHONY: $(PHONY)
v5.9
  1# SPDX-License-Identifier: GPL-2.0-only
  2# Makefile for the different targets used to generate full packages of a kernel
  3
  4include $(srctree)/scripts/Kbuild.include
 
  5
  6# RPM target
  7# ---------------------------------------------------------------------------
  8# The rpm target generates two rpm files:
  9# /usr/src/packages/SRPMS/kernel-2.6.7rc2-1.src.rpm
 10# /usr/src/packages/RPMS/i386/kernel-2.6.7rc2-1.<arch>.rpm
 11# The src.rpm files includes all source for the kernel being built
 12# The <arch>.rpm includes kernel configuration, modules etc.
 13#
 14# Process to create the rpm files
 15# a) clean the kernel
 16# b) Generate .spec file
 17# c) Build a tar ball, using symlink to make kernel version
 18#    first entry in the path
 19# d) and pack the result to a tar.gz file
 20# e) generate the rpm files, based on kernel.spec
 21# - Use /. to avoid tar packing just the symlink
 22
 23# Note that the rpm-pkg target cannot be used with KBUILD_OUTPUT,
 24# but the binrpm-pkg target can; for some reason O= gets ignored.
 25
 26# Remove hyphens since they have special meaning in RPM filenames
 27KERNELPATH := kernel-$(subst -,_,$(KERNELRELEASE))
 28KDEB_SOURCENAME ?= linux-$(KERNELRELEASE)
 29KBUILD_PKG_ROOTCMD ?="fakeroot -u"
 30export KDEB_SOURCENAME
 31# Include only those top-level files that are needed by make, plus the GPL copy
 32TAR_CONTENT := $(KBUILD_ALLDIRS) .config .scmversion Makefile \
 33               Kbuild Kconfig COPYING $(wildcard localversion*)
 34MKSPEC     := $(srctree)/scripts/package/mkspec
 35
 36quiet_cmd_src_tar = TAR     $(2).tar.gz
 37      cmd_src_tar = \
 38if test "$(objtree)" != "$(srctree)"; then \
 39	echo >&2; \
 40	echo >&2 "  ERROR:"; \
 41	echo >&2 "  Building source tarball is not possible outside the"; \
 42	echo >&2 "  kernel source tree. Don't set KBUILD_OUTPUT, or use the"; \
 43	echo >&2 "  binrpm-pkg or bindeb-pkg target instead."; \
 44	echo >&2; \
 45	false; \
 46fi ; \
 47$(srctree)/scripts/setlocalversion --save-scmversion; \
 48tar -I $(KGZIP) -c $(RCS_TAR_IGNORE) -f $(2).tar.gz \
 49	--transform 's:^:$(2)/:S' $(TAR_CONTENT) $(3); \
 50rm -f $(objtree)/.scmversion
 51
 52# rpm-pkg
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 53# ---------------------------------------------------------------------------
 54PHONY += rpm-pkg
 55rpm-pkg:
 56	$(MAKE) clean
 57	$(CONFIG_SHELL) $(MKSPEC) >$(objtree)/kernel.spec
 58	$(call cmd,src_tar,$(KERNELPATH),kernel.spec)
 59	+rpmbuild $(RPMOPTS) --target $(UTS_MACHINE) -ta $(KERNELPATH).tar.gz \
 60	--define='_smp_mflags %{nil}'
 61
 62# binrpm-pkg
 63# ---------------------------------------------------------------------------
 64PHONY += binrpm-pkg
 65binrpm-pkg:
 66	$(MAKE) -f $(srctree)/Makefile
 67	$(CONFIG_SHELL) $(MKSPEC) prebuilt > $(objtree)/binkernel.spec
 68	+rpmbuild $(RPMOPTS) --define "_builddir $(objtree)" --target \
 69		$(UTS_MACHINE) -bb $(objtree)/binkernel.spec
 70
 71PHONY += deb-pkg
 72deb-pkg:
 73	$(MAKE) clean
 74	$(CONFIG_SHELL) $(srctree)/scripts/package/mkdebian
 75	$(call cmd,src_tar,$(KDEB_SOURCENAME))
 76	origversion=$$(dpkg-parsechangelog -SVersion |sed 's/-[^-]*$$//');\
 77		mv $(KDEB_SOURCENAME).tar.gz ../$(KDEB_SOURCENAME)_$${origversion}.orig.tar.gz
 78	+dpkg-buildpackage -r$(KBUILD_PKG_ROOTCMD) -a$$(cat debian/arch) $(DPKG_FLAGS) -i.git -us -uc
 79
 80PHONY += bindeb-pkg
 81bindeb-pkg:
 82	$(CONFIG_SHELL) $(srctree)/scripts/package/mkdebian
 83	+dpkg-buildpackage -r$(KBUILD_PKG_ROOTCMD) -a$$(cat debian/arch) $(DPKG_FLAGS) -b -nc -uc
 84
 85PHONY += intdeb-pkg
 86intdeb-pkg:
 87	+$(CONFIG_SHELL) $(srctree)/scripts/package/builddeb
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 88
 89# snap-pkg
 90# ---------------------------------------------------------------------------
 91PHONY += snap-pkg
 92snap-pkg:
 93	rm -rf $(objtree)/snap
 94	mkdir $(objtree)/snap
 95	$(MAKE) clean
 96	$(call cmd,src_tar,$(KERNELPATH))
 97	sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
 98		s@SRCTREE@$(shell realpath $(KERNELPATH).tar.gz)@" \
 99		$(srctree)/scripts/package/snapcraft.template > \
100		$(objtree)/snap/snapcraft.yaml
101	cd $(objtree)/snap && \
102	snapcraft --target-arch=$(UTS_MACHINE)
103
104# tarball targets
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
105# ---------------------------------------------------------------------------
106tar-pkgs := dir-pkg tar-pkg targz-pkg tarbz2-pkg tarxz-pkg
107PHONY += $(tar-pkgs)
108$(tar-pkgs):
109	$(MAKE) -f $(srctree)/Makefile
110	+$(CONFIG_SHELL) $(srctree)/scripts/package/buildtar $@
111
112# perf-pkg - generate a source tarball with perf source
113# ---------------------------------------------------------------------------
114
115perf-tar=perf-$(KERNELVERSION)
116
117quiet_cmd_perf_tar = TAR
118      cmd_perf_tar = \
119git --git-dir=$(srctree)/.git archive --prefix=$(perf-tar)/         \
120	HEAD^{tree} $$(cd $(srctree);                               \
121		       echo $$(cat tools/perf/MANIFEST)) \
122	-o $(perf-tar).tar;                                         \
123mkdir -p $(perf-tar);                                               \
124git --git-dir=$(srctree)/.git rev-parse HEAD > $(perf-tar)/HEAD;    \
125(cd $(srctree)/tools/perf;                                          \
126util/PERF-VERSION-GEN $(CURDIR)/$(perf-tar)/);              \
127tar rf $(perf-tar).tar $(perf-tar)/HEAD $(perf-tar)/PERF-VERSION-FILE; \
128rm -r $(perf-tar);                                                  \
129$(if $(findstring tar-src,$@),,                                     \
130$(if $(findstring bz2,$@),$(KBZIP2),                                 \
131$(if $(findstring gz,$@),$(KGZIP),                                  \
132$(if $(findstring xz,$@),$(XZ),                                     \
133$(error unknown target $@))))                                       \
134	-f -9 $(perf-tar).tar)
135
136perf-tar-pkgs := perf-tar-src-pkg perf-targz-src-pkg perf-tarbz2-src-pkg perf-tarxz-src-pkg
137PHONY += $(perf-tar-pkgs)
138$(perf-tar-pkgs):
139	$(call cmd,perf_tar)
140
141# Help text displayed when executing 'make help'
142# ---------------------------------------------------------------------------
143PHONY += help
144help:
145	@echo '  rpm-pkg             - Build both source and binary RPM kernel packages'
 
146	@echo '  binrpm-pkg          - Build only the binary kernel RPM package'
147	@echo '  deb-pkg             - Build both source and binary deb kernel packages'
 
148	@echo '  bindeb-pkg          - Build only the binary kernel deb package'
149	@echo '  snap-pkg            - Build only the binary kernel snap package'
150	@echo '                        (will connect to external hosts)'
151	@echo '  dir-pkg             - Build the kernel as a plain directory structure'
152	@echo '  tar-pkg             - Build the kernel as an uncompressed tarball'
153	@echo '  targz-pkg           - Build the kernel as a gzip compressed tarball'
154	@echo '  tarbz2-pkg          - Build the kernel as a bzip2 compressed tarball'
155	@echo '  tarxz-pkg           - Build the kernel as a xz compressed tarball'
156	@echo '  perf-tar-src-pkg    - Build $(perf-tar).tar source tarball'
157	@echo '  perf-targz-src-pkg  - Build $(perf-tar).tar.gz source tarball'
158	@echo '  perf-tarbz2-src-pkg - Build $(perf-tar).tar.bz2 source tarball'
159	@echo '  perf-tarxz-src-pkg  - Build $(perf-tar).tar.xz source tarball'
 
 
 
 
 
 
 
 
 
 
 
 
 
 
160
161.PHONY: $(PHONY)